#!/usr/bin/perl
use Mysql;

#    RingWorld SQL v1.9 - webring management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Variables Section
open (F, "<rworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

######################################################################
# Main Section                                                       #
######################################################################
# Get data
($farg,$sarg)=split("&",$ENV{QUERY_STRING});
($webring)=$farg=~/=(.+)/;
($start)=$sarg=~/=(.+)/;

# Get info
if ($webring)
{
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rname,stype FROM rw_rings WHERE rid=$webring");
($fullrn,$stype)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($fullrn)
{
$sth=$dbh->query("LOCK TABLES rw_users READ, rw_sites READ") if ($locktables);
$sth=$dbh->query("SELECT sname,sdescr,surl FROM rw_sites,rw_users WHERE (rid=$webring AND rw_sites.uid=rw_users.uid AND status=1) ORDER BY sname");
while (($tit,$desc,$uurl)=$sth->fetchrow)
{
	push(@ndata,"$tit\t$uurl\t$desc");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
@data=@ndata;
push (@footer,"<table width=\"100%\" border=0><tr>");
$icount=scalar(@data);
if (scalar (@data)>10)
{
	if ($start>0)
	{
		$pstart=$start-1;
		push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/rwgetlst.pl?n=$webring&s=$pstart\"><img src=\"$ringworld/images/rwprev.gif\" border=0></a></td>");
	}
	else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
	push(@footer,"<td width=\"70%\" align=\"center\"><img src=\"$ringworld/images/rwline.gif\"></td>");
	if ($start*10+10<scalar(@data))
	{
		$nstart=$start+1;
		push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/rwgetlst.pl?n=$webring&s=$nstart\"><img src=\"$ringworld/images/rwnext.gif\" border=0></a></td>");
	}
	else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
}
else {push(@footer,"<td width=\"100%\" align=\"center\"><img src=\"$ringworld/images/rwline.gif\"></td>");}
push (@footer,"</tr></table>");
if ($start*10+10>scalar(@data))
{
	$i=$start*10;
	while($i<scalar(@data))
	{
		($title,$uurl,$desc)=split("\t",$data[$i]);
		push(@result,"<li><a href=\"$uurl\"><font face=\"Arial\" size=\"2\">$title</font></a><br><font face=\"Arial\" size=\"2\">$desc</font></li>\n");
		$i++;
	}
}
else
{
	$i=$start*10;
	$last=$i+10;
	while($i<$last)
	{
		($title,$uurl,$desc)=split("\t",$data[$i]);
		push(@result,"<li><a href=\"$uurl\"><font face=\"Arial\" size=\"2\">$title</font></a><br><font face=\"Arial\" size=\"2\">$desc</font></li>\n");
		$i++;
	}
}
if (!@result)
{
	push(@result,"<li>Empty WebRing</li>");
}
}
else
{
	push(@result,"<li>Sorry, webring is not longer exist</li>");
	push(@footer,"<table width=\"100%\" border=0><tr><td width=\"100%\" align=\"center\"><img src=\"$ringworld/images/rwline.gif\"></td></tr></table>");
}
}
else
{
	push(@result,"<li>Sorry, webring is not longer exist</li>");
	push(@footer,"<table width=\"100%\" border=0><tr><td width=\"100%\" align=\"center\"><img src=\"$ringworld/images/rwline.gif\"></td></tr></table>");
}
# Print Results
$sth="";
$dbh="";
open (F,"<$rwpath/template/sitelist.tpl");
@html=<F>;
close (F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
