#!/usr/bin/perl
use Mysql;

#    RingWorld SQL v1.9 - webring management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Variables Section
open (F, "<rworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

######################################################################
# Main Section                                                       #
######################################################################
# Get data
sysread(STDIN,$data,$ENV{CONTENT_LENGTH});
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		if ($data{$field} eq "")
		{
			$data{$field}=$value;
		}
		else
		{
			$data{$field}.=",$value";
		}
	}
}
$data{method}="genset" unless ($data{method});
$destination=$data{method};
$encpw=substr(crypt($data{password},$data{password}),2);
&$destination if ($admlogin eq $data{name} && $admpass eq $encpw);
push(@errors,"Incorrect username or password<br>");
&error(@errors);

sub genset
{
$selected{genset}="selected";
$result=qq~
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>GENERAL SETTINGS</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="chgenset">
<table width="100%">
<tr><td width="40%"><font size=1><b>RingWorld title</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="title" value="$title"></font></td></tr>
<tr><td width="40%"><font size=1><b>SystemID</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="sysid" value="$sysid"></font></td></tr>
<tr><td width="40%"><font size=1><b>Path to RingWorld directory</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="rwpath" value="$rwpath"></font></td></tr>
<tr><td width="40%"><font size=1><b>Path to backup directory</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="backuppath" value="$backuppath"></font></td></tr>
<tr><td width="40%"><font size=1><b>Path to messages directory</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="messpath" value="$messpath"></font></td></tr>
<tr><td width="40%"><font size=1><b>URL to RingWorld directory</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="ringworld" value="$ringworld"></font></td></tr>
<tr><td width="40%"><font size=1><b>URL to CGI-BIN directory</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="cgi" value="$cgi"></font></td></tr>
<tr><td width="40%"><font size=1><b>Path to sendmail</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="mailprog" value="$mailprog"></font></td></tr>
<tr><td width="40%"><font size=1><b>Admin e-mail</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="rwemail" value="$rwemail"></font></td></tr>
<tr><td width="40%"><font size=1><b>URL to your site</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="furl" value="$furl"></font></td></tr>
<tr><td width="40%"><font size=1><b>Admin name</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="admname" value="$admname"></font></td></tr>
<tr><td width="40%"><font size=1><b>Checking type (1-Auto/0-Manual)</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="autocheck" value="$autocheck"></font></td></tr>
<tr><td width="40%"><font size=1><b>WR URL Required (1-Yes/0-No)</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="wurlrequired" value="$wurlrequired"></font></td></tr>
<tr><td width="40%"><font size=1><b>Admin login</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="newname" value="$data{name}"></font></td></tr>
<tr><td width="40%"><font size=1><b>Admin password</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="newpass" value="$data{password}"></font></td></tr>
<tr><td width="40%"><font size=1><b>Mysql server hostname</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="mysqlhost" value="$mysqlhost"></font></td></tr>
<tr><td width="40%"><font size=1><b>Mysql database name</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="mysqldb" value="$mysqldb"></font></td></tr>
<tr><td width="40%"><font size=1><b>Mysql login</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="mysqllogin" value="$mysqllogin"></font></td></tr>
<tr><td width="40%"><font size=1><b>Mysql password</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="mysqlpassword" value="$mysqlpassword"></font></td></tr>
<tr><td width="40%"><font size=1><b>Lock tables (1-Yes/0-No)</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="locktables" value="$locktables"></font></td></tr>
<tr><td colspan=2 align="center"><font size=2>Please, use your license number: $license, when contact techsupport by email <a href="mailto:perlbox\@td-systems.com">perlbox\@td-systems.com</a></font></td></tr>
<tr><td colspan=2 align="center"><input type="submit" value="Change general settings"></td></tr>
</table></form></td></tr>
~;
&closedb;
open(F,"<$rwpath/template/admin.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub chgenset
{
unless ($data{newname})
{
	$data{newname}=$data{name};
}
else
{
	$data{name}=$data{newname};
}
unless ($data{newpass})
{
	$data{newpass}=$encpw;
}
else
{
	$data{password}=$data{newpass};
	$data{newpass}=substr(crypt($data{password},$data{password}),2);
}
open(F,">rworld.cfg");
print F qq~#    RingWorld SQL v1.9 - webring management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\$rwpath="$data{rwpath}";
\$backuppath="$data{backuppath}";
\$messpath="$data{messpath}";
\$cgi="$data{cgi}";
\$ringworld="$data{ringworld}";
\$sysid="$data{sysid}";
\$mailprog="$data{mailprog}";
\$rwemail='$data{rwemail}';
\$furl="$data{furl}";
\$title="$data{title}";
\$autocheck=$data{autocheck};
\$admname="$data{admname}";
\$wurlrequired=$data{wurlrequired};
\$license="$license";
\$admlogin="$data{newname}";
\$admpass="$data{newpass}";
\$mysqlhost="$data{mysqlhost}";
\$mysqldb="$data{mysqldb}";
\$mysqllogin="$data{mysqllogin}";
\$mysqlpassword="$data{mysqlpassword}";
\$locktables=$data{locktables};
~;
close(F);
open (F, "<rworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
&genset;
}
sub mailmess
{
$selected{mailmess}="selected";
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT site_reg_to_leader,site_reg_to_user,ring_reg_to_admin,lost_pass,leader_site_remove,leader_site_disable,leader_site_enable,leader_site_accept,leader_site_decline,sitelist,admin_ring_remove,admin_ring_disable,admin_ring_enable,admin_ring_accept,admin_ring_decline,mail_header,mail_footer FROM rw_settings");
($site_reg_to_leader,$site_reg_to_user,$ring_reg_to_admin,$lost_pass,$leader_site_remove,$leader_site_disable,$leader_site_enable,$leader_site_accept,$leader_site_decline,$sitelist,$admin_ring_remove,$admin_ring_disable,$admin_ring_enable,$admin_ring_accept,$admin_ring_decline,$mail_header,$mail_footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$result=qq~
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>SITE REGISTRATION MESSAGE TO LEADER</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ch_site_reg_to_leader">
<table width="100%">
<tr><td width="100%"><font size=2><textarea name=text cols=46 rows=7>$site_reg_to_leader</textarea></font></td></tr>
<tr><td align="center"><input type="submit" value="Save changes"></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>SITE REGISTRATION MESSAGE TO USER</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ch_site_reg_to_user">
<table width="100%">
<tr><td width="100%"><font size=2><textarea name=text cols=46 rows=7>$site_reg_to_user</textarea></font></td></tr>
<tr><td align="center"><input type="submit" value="Save changes"></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>RING REGISTRATION MESSAGE TO ADMIN</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ch_ring_reg_to_admin">
<table width="100%">
<tr><td width="100%"><font size=2><textarea name=text cols=46 rows=7>$ring_reg_to_admin</textarea></font></td></tr>
<tr><td align="center"><input type="submit" value="Save changes"></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>PASSWORD RECOVERY MESSAGE</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ch_lost_pass">
<table width="100%">
<tr><td width="100%"><font size=2><textarea name=text cols=46 rows=7>$lost_pass</textarea></font></td></tr>
<tr><td align="center"><input type="submit" value="Save changes"></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>SITE REMOVAL MESSAGE</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ch_leader_site_remove">
<table width="100%">
<tr><td width="100%"><font size=2><textarea name=text cols=46 rows=7>$leader_site_remove</textarea></font></td></tr>
<tr><td align="center"><input type="submit" value="Save changes"></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>SITE DISABLED MESSAGE</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ch_leader_site_disable">
<table width="100%">
<tr><td width="100%"><font size=2><textarea name=text cols=46 rows=7>$leader_site_disable</textarea></font></td></tr>
<tr><td align="center"><input type="submit" value="Save changes"></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>SITE ENABLED MESSAGE</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ch_leader_site_enable">
<table width="100%">
<tr><td width="100%"><font size=2><textarea name=text cols=46 rows=7>$leader_site_enable</textarea></font></td></tr>
<tr><td align="center"><input type="submit" value="Save changes"></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>SITE ACCEPTED MESSAGE</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ch_leader_site_accept">
<table width="100%">
<tr><td width="100%"><font size=2><textarea name=text cols=46 rows=7>$leader_site_accept</textarea></font></td></tr>
<tr><td align="center"><input type="submit" value="Save changes"></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>SITE DECLINED MESSAGE</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ch_leader_site_decline">
<table width="100%">
<tr><td width="100%"><font size=2><textarea name=text cols=46 rows=7>$leader_site_decline</textarea></font></td></tr>
<tr><td align="center"><input type="submit" value="Save changes"></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>SITELIST MESSAGE</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ch_sitelist">
<table width="100%">
<tr><td width="100%"><font size=2><textarea name=text cols=46 rows=7>$sitelist</textarea></font></td></tr>
<tr><td align="center"><input type="submit" value="Save changes"></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>RING REMOVAL MESSAGE</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ch_admin_ring_remove">
<table width="100%">
<tr><td width="100%"><font size=2><textarea name=text cols=46 rows=7>$admin_ring_remove</textarea></font></td></tr>
<tr><td align="center"><input type="submit" value="Save changes"></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>RING DISABLED MESSAGE</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ch_admin_ring_disable">
<table width="100%">
<tr><td width="100%"><font size=2><textarea name=text cols=46 rows=7>$admin_ring_disable</textarea></font></td></tr>
<tr><td align="center"><input type="submit" value="Save changes"></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>RING ENABLED MESSAGE</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ch_admin_ring_enable">
<table width="100%">
<tr><td width="100%"><font size=2><textarea name=text cols=46 rows=7>$admin_ring_enable</textarea></font></td></tr>
<tr><td align="center"><input type="submit" value="Save changes"></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>RING ACCEPTED MESSAGE</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ch_admin_ring_accept">
<table width="100%">
<tr><td width="100%"><font size=2><textarea name=text cols=46 rows=7>$admin_ring_accept</textarea></font></td></tr>
<tr><td align="center"><input type="submit" value="Save changes"></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>RING DECLINED MESSAGE</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ch_admin_ring_decline">
<table width="100%">
<tr><td width="100%"><font size=2><textarea name=text cols=46 rows=7>$admin_ring_decline</textarea></font></td></tr>
<tr><td align="center"><input type="submit" value="Save changes"></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>MAIL HEADER</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ch_mail_header">
<table width="100%">
<tr><td width="100%"><font size=2><textarea name=text cols=46 rows=7>$mail_header</textarea></font></td></tr>
<tr><td align="center"><input type="submit" value="Save changes"></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>MAIL FOOTER</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ch_mail_footer">
<table width="100%">
<tr><td width="100%"><font size=2><textarea name=text cols=46 rows=7>$mail_footer</textarea></font></td></tr>
<tr><td align="center"><input type="submit" value="Save changes"></td></tr>
</table></form></td></tr>
~;
&closedb;
open(F,"<$rwpath/template/admin.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub ch_site_reg_to_leader
{
	$data{text}=~s/'/\\'/g;
	$sth=$dbh->query("LOCK TABLES rw_settings WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_settings SET site_reg_to_leader='$data{text}'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&mailmess;
}
sub ch_site_reg_to_user
{
	$data{text}=~s/'/\\'/g;
	$sth=$dbh->query("LOCK TABLES rw_settings WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_settings SET site_reg_to_user='$data{text}'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&mailmess;
}
sub ch_ring_reg_to_admin
{
	$data{text}=~s/'/\\'/g;
	$sth=$dbh->query("LOCK TABLES rw_settings WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_settings SET ring_reg_to_admin='$data{text}'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&mailmess;
}
sub ch_lost_pass
{
	$data{text}=~s/'/\\'/g;
	$sth=$dbh->query("LOCK TABLES rw_settings WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_settings SET lost_pass='$data{text}'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&mailmess;
}
sub ch_leader_site_remove
{
	$data{text}=~s/'/\\'/g;
	$sth=$dbh->query("LOCK TABLES rw_settings WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_settings SET leader_site_remove='$data{text}'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&mailmess;
}
sub ch_leader_site_disable
{
	$data{text}=~s/'/\\'/g;
	$sth=$dbh->query("LOCK TABLES rw_settings WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_settings SET leader_site_disable='$data{text}'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&mailmess;
}
sub ch_leader_site_enable
{
	$data{text}=~s/'/\\'/g;
	$sth=$dbh->query("LOCK TABLES rw_settings WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_settings SET leader_site_enable='$data{text}'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&mailmess;
}
sub ch_leader_site_accept
{
	$data{text}=~s/'/\\'/g;
	$sth=$dbh->query("LOCK TABLES rw_settings WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_settings SET leader_site_accept='$data{text}'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&mailmess;
}
sub ch_leader_site_decline
{
	$data{text}=~s/'/\\'/g;
	$sth=$dbh->query("LOCK TABLES rw_settings WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_settings SET leader_site_decline='$data{text}'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&mailmess;
}
sub ch_sitelist
{
	$data{text}=~s/'/\\'/g;
	$sth=$dbh->query("LOCK TABLES rw_settings WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_settings SET sitelist='$data{text}'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&mailmess;
}
sub ch_admin_ring_remove
{
	$data{text}=~s/'/\\'/g;
	$sth=$dbh->query("LOCK TABLES rw_settings WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_settings SET admin_ring_remove='$data{text}'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&mailmess;
}
sub ch_admin_ring_disable
{
	$data{text}=~s/'/\\'/g;
	$sth=$dbh->query("LOCK TABLES rw_settings WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_settings SET admin_ring_disable='$data{text}'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&mailmess;
}
sub ch_admin_ring_enable
{
	$data{text}=~s/'/\\'/g;
	$sth=$dbh->query("LOCK TABLES rw_settings WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_settings SET admin_ring_enable='$data{text}'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&mailmess;
}
sub ch_admin_ring_accept
{
	$data{text}=~s/'/\\'/g;
	$sth=$dbh->query("LOCK TABLES rw_settings WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_settings SET admin_ring_accept='$data{text}'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&mailmess;
}
sub ch_admin_ring_decline
{
	$data{text}=~s/'/\\'/g;
	$sth=$dbh->query("LOCK TABLES rw_settings WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_settings SET admin_ring_decline='$data{text}'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&mailmess;
}
sub ch_mail_header
{
	$data{text}=~s/'/\\'/g;
	$sth=$dbh->query("LOCK TABLES rw_settings WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_settings SET mail_header='$data{text}'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&mailmess;
}
sub ch_mail_footer
{
	$data{text}=~s/'/\\'/g;
	$sth=$dbh->query("LOCK TABLES rw_settings WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_settings SET mail_footer='$data{text}'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&mailmess;
}
sub webcont
{
$selected{webcont}="selected";
$sth=$dbh->query("LOCK TABLES rw_sites READ, rw_rings READ, rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT COUNT(sid),rid FROM rw_sites GROUP BY rid");
while (($sites,$rid)=$sth->fetchrow){$sites[$rid]=$sites;}
$sth=$dbh->query("SELECT rid,rname,status FROM rw_rings,rw_users WHERE (rw_rings.uid=rw_users.uid AND status>0) ORDER BY rname");
while (($rid,$rname,$status)=$sth->fetchrow)
{
	push(@rings,"$rid\t$rname\t$status");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
foreach (@rings)
{
	($rid,$fullrn,$status)=split("\t",$_);
	$sites[$rid]=0 unless ($sites[$rid]);
	$rings.="<option value=\"$rid\">$fullrn ($sites[$rid] sites)</option>\n";
	$ringsen.="<option value=\"$rid\">$fullrn ($sites[$rid] sites)</option>\n" if ($status==1);
	$ringsdis.="<option value=\"$rid\">$fullrn ($sites[$rid] sites)</option>\n" if ($status==2);
}
$result=qq~
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>REMOVE RING</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="remove"><select name=ring>$rings</select><input type="Submit" name="Submit" value="Remove ring"><br></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>GET/EDIT RING INFO</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="get"><select name=ring>$rings</select><input type="Submit" name="Submit" value="Get info"><br></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>DISABLE RING</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="disable"><select name=ring>$ringsen</select><input type="Submit" value="Proceed"><br></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>ENABLE RING</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="enable"><select name=ring>$ringsdis</select><input type="Submit" value="Proceed"><br></form></td></tr>
~;
&closedb;
open(F,"<$rwpath/template/admin.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub remove
{
$selected{webcont}="selected";
if ($data{ring})
{
$result=qq~
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>ARE YOU SURE TO REMOVE RING?</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="remove_c"><input type="hidden" name="ring" value="$data{ring}">
<table width="100%">
<tr><td><font size=2><b>All websites belong to choosen ring should be removed too</b></font></td></tr>
<tr><td align="center"><input type="submit" value="Yes, Im sure"></td></tr>
</table></form></td></tr>
~;
&closedb;
open(F,"<$rwpath/template/admin.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
&webcont;
}
sub remove_c
{
if ($data{ring})
{
$sth=$dbh->query("LOCK TABLES rw_sites WRITE, rw_rings WRITE, rw_users WRITE") if ($locktables);
$sth=$dbh->query("SELECT uid FROM rw_rings WHERE rid=$data{ring}");
$uid=$sth->fetchrow;
$sth=$dbh->query("SELECT uid FROM rw_sites WHERE rid=$data{ring}");
@uid=$sth->fetchcol;
$sth=$dbh->query("SELECT email,name FROM rw_users WHERE uid=$uid");
($email,$name)=$sth->fetchrow;
$sth=$dbh->query("DELETE FROM rw_rings WHERE rid=$data{ring}");
$sth=$dbh->query("DELETE FROM rw_sites WHERE rid=$data{ring}");
$sth=$dbh->query("DELETE FROM rw_users WHERE uid=$uid");
foreach(@uid)
{
	$sth=$dbh->query("DELETE FROM rw_users WHERE uid=$_");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unlink("$rwpath/logo/$data{ring}.gif");
unlink("$messpath/$uid.msg");
open (MAIL,"|$mailprog");
print MAIL "To: $email ($name)\n";
print MAIL "From: $rwemail ($title)\n";
print MAIL "Subject: Webring Alert\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT admin_ring_remove,mail_header,mail_footer FROM rw_settings");
($text,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$text="print MAIL \"$text\";";
print MAIL "$header\n";
eval $text;
print MAIL "$footer\n";
print MAIL "\n.\n";
close (MAIL);
}
&webcont;
}
sub disable
{
if ($data{ring})
{
$sth=$dbh->query("LOCK TABLES rw_rings READ, rw_users WRITE") if ($locktables);
$sth=$dbh->query("SELECT uid FROM rw_rings WHERE rid=$data{ring}");
$uid=$sth->fetchrow;
$sth=$dbh->query("UPDATE rw_users SET status=2 WHERE uid=$uid");
$sth=$dbh->query("SELECT email,name FROM rw_users WHERE uid=$uid");
($email,$name)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
open (MAIL,"|$mailprog");
print MAIL "To: $email ($name)\n";
print MAIL "From: $rwemail ($title)\n";
print MAIL "Subject: Webring disabled\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT admin_ring_disable,mail_header,mail_footer FROM rw_settings");
($text,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$text="print MAIL \"$text\";";
print MAIL "$header\n";
eval $text;
print MAIL "$footer\n";
print MAIL "\n.\n";
close (MAIL);
}
&webcont;
}
sub enable
{
if ($data{ring})
{
$sth=$dbh->query("LOCK TABLES rw_rings READ, rw_users WRITE") if ($locktables);
$sth=$dbh->query("SELECT uid FROM rw_rings WHERE rid=$data{ring}");
$uid=$sth->fetchrow;
$sth=$dbh->query("UPDATE rw_users SET status=1 WHERE uid=$uid");
$sth=$dbh->query("SELECT email,name FROM rw_users WHERE uid=$uid");
($email,$name)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
open (MAIL,"|$mailprog");
print MAIL "To: $email ($name)\n";
print MAIL "From: $rwemail ($title)\n";
print MAIL "Subject: Webring enabled\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT admin_ring_enable,mail_header,mail_footer FROM rw_settings");
($text,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$text="print MAIL \"$text\";";
print MAIL "$header\n";
eval $text;
print MAIL "$footer\n";
print MAIL "\n.\n";
close (MAIL);
}
&webcont;
}
sub get
{
$selected{webcont}="selected";
if ($data{ring})
{
$sth=$dbh->query("LOCK TABLES rw_rings READ,rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT rname,rurl,rdescr,caid,email FROM rw_rings,rw_users WHERE (rid=$data{ring} AND rw_rings.uid=rw_users.uid)");
($rname,$rurl,$rdescr,$rcaid,$email)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$rdescr=~s/\<br\>/\n/gi;
$sth=$dbh->query("LOCK TABLES rw_categories READ") if ($locktables);
$sth=$dbh->query("SELECT caid,category,subcategory FROM rw_categories ORDER BY category,subcategory");
while (($caid,$category,$subcategory)=$sth->fetchrow)
{
	if ($caid==$rcaid)
	{
		$cats.="<option value=\"$caid\" selected>$category:$subcategory</option>\n";
	}
	else
	{
		$cats.="<option value=\"$caid\">$category:$subcategory</option>\n";
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$result=qq~
<tr><td><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="edit"><input type="hidden" name="ring" value="$data{ring}">
<table cellpadding=0 cellspacing=0 width="100%">
<tr><td width="100%" colspan=4 bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>CHANGE WEBRING INFORMATION</center></font></td></tr>
<tr><td width="25%"><font face="Arial" size="2">Ringname:</font></td><td width="25%"><input type="text" name="uname" value="$rname" size=15 maxlength=50></td><td width="25%"><font face="Arial" size="2">E-Mail:</font></td><td width="25%"><input type="text" value="$email" name="email" size=15 maxlength=50></td></tr>
<tr><td width="25%"><font face="Arial" size="2">WebRing URL:</font></td><td width="75%" colspan=3 align="right"><input type=text name="wurl" size=55 value="$rurl"></td></tr>
<tr><td width="25%"><font face="Arial" size="2">WebRing description:</font></td><td width="75%" colspan=3 align="right"><textarea name="description" cols=41 rows=4 wrap="virtual">$rdescr</textarea></td></tr>
<tr><td width="25%"><font face="Arial" size="2">Category:</font></td><td width="75%" colspan=3 align="right"><select name="categ">$cats</select></td></tr>
<tr><td width="100%" colspan=4 align="right"><input type="Submit" name="Submit" value="Change"></td></tr>
</table></form></td></tr>
<tr><td>
~;
&closedb;
open(F,"<$rwpath/template/admin.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
&webcont;
}
sub edit
{
if ($data{ring})
{
$data{uname}=~s/'/\\'/g;
$data{description}=~s/'/\\'/g;
$data{description}=~s/\r//g;
$sth=$dbh->query("LOCK TABLES rw_rings WRITE, rw_users WRITE") if ($locktables);
$sth=$dbh->query("SELECT uid FROM rw_rings WHERE rid=$data{ring}");
$uid=$sth->fetchrow;
$sth=$dbh->query("UPDATE rw_users SET email='$data{email}' WHERE uid=$uid");
$sth=$dbh->query("UPDATE rw_rings SET rname='$data{uname}',rurl='$data{wurl}',caid=$data{categ},rdescr='$data{description}' WHERE rid=$data{ring}");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&get;
}
sub webnew
{
$selected{webnew}="selected";
$sth=$dbh->query("LOCK TABLES rw_users READ, rw_rings READ, rw_categories READ") if ($locktables);
$sth=$dbh->query("SELECT rw_users.uid,rw_rings.rid,name,email,rname,rurl,rdescr,category,subcategory FROM rw_users,rw_rings,rw_categories WHERE (acctype=1 AND status=0 AND rw_users.uid=rw_rings.uid AND rw_rings.caid=rw_categories.caid) ORDER BY rname");
while (($uid,$rid,$name,$email,$rname,$rurl,$rdescr,$category,$subcategory)=$sth->fetchrow)
{
	$rname=qq~<a href="$rurl" target="_blank">$rname</a>~ if $rurl;
	$result.=qq~<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>WEBRING: $rname</center></font></td></tr><tr><td width="100%"><font face="Arial" size="2"><b>Owner Name:</b> $name<br><b>Owner e-mail:</b> $email<br><b>Description:</b><br> $rdescr</font><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="ring" value="$uid"><center><input type=submit name=method value=accept><input type=submit name=method value=decline></center></form></td></tr>\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$result="<tr><td align=center><font size=2>No new webrings</font></td></tr>\n" if (!$result);
&closedb;
open(F,"<$rwpath/template/admin.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub accept
{
if ($data{ring})
{
$sth=$dbh->query("LOCK TABLES rw_users WRITE") if ($locktables);
$sth=$dbh->query("UPDATE rw_users SET status=1 WHERE uid=$data{ring}");
$sth=$dbh->query("SELECT username,password,name,email FROM rw_users WHERE uid=$data{ring}");
($user,$pass,$name,$email)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
open (MAIL,"|$mailprog");
print MAIL "To: $email ($name)\n";
print MAIL "From: $rwemail ($title)\n";
print MAIL "Subject: Webring Accepted\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT admin_ring_accept,mail_header,mail_footer FROM rw_settings");
($text,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$text="print MAIL \"$text\";";
print MAIL "$header\n";
eval $text;
print MAIL "$footer\n";
print MAIL "\n.\n";
close (MAIL);
}
&webnew;
}
sub decline
{
if ($data{ring})
{
$sth=$dbh->query("LOCK TABLES rw_users WRITE, rw_rings WRITE") if ($locktables);
$sth=$dbh->query("SELECT username,password,name,email FROM rw_users WHERE uid=$data{ring}");
($user,$pass,$name,$email)=$sth->fetchrow;
$sth=$dbh->query("DELETE FROM rw_users WHERE uid=$data{ring}");
$sth=$dbh->query("DELETE FROM rw_rings WHERE uid=$data{ring}");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
open (MAIL,"|$mailprog");
print MAIL "To: $email ($name)\n";
print MAIL "From: $rwemail ($title)\n";
print MAIL "Subject: Webring Declined\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT admin_ring_decline,mail_header,mail_footer FROM rw_settings");
($text,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$text="print MAIL \"$text\";";
print MAIL "$header\n";
eval $text;
print MAIL "$footer\n";
print MAIL "\n.\n";
close (MAIL);
}
&webnew;
}
sub maillist
{
$selected{maillist}="selected";
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid,rname FROM rw_rings ORDER BY rname");
while (($rid,$rname,$status)=$sth->fetchrow)
{
	$rings.="<option value=\"$rid\">$rname members</option>\r";
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if (-e "$messpath/admin.msg")
{
	($atime,$mtime)=(stat("$messpath/admin.msg"))[8,9];
	($day,$month,$date,$time,$year)=split(" ",scalar localtime($mtime));
$result=qq~
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>LAST MESSAGE</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="restore_message">
<font size="2">Has been sent on $date $month $year $time
<center><input type="Submit" value="Restore message"></center><br></font></form></td></tr>
~;
}
$result.=qq~
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>SEND MAIL</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="sendmail"><input type="hidden" name="sender" value="$rwemail ($title)"><input type="hidden" name="senname" value="$admname (RingMaster)">
<font size="2">Recepients: <select name="recepient">
<option value="all">All members</option>
<option value="ringleader">All Ringleaders</option>
$rings
</select><br>
Subject: <input type="text" name="subject" size=54 maxlength=100 value="$subject"><br>
<textarea name="body" cols=47 rows=5>
$body
</textarea>
<center><input type="Submit" value="Send mail"></center><br></font></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>DOWNLOAD MAILLIST</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="downmail">
<font size="2">Download list of: <select name="recepient">
<option value="all">All members</option>
<option value="ringleader">All Ringleaders</option>
$rings
</select><br>
<center><input type="Submit" value="Download"></center><br></font></form></td></tr>
~;
&closedb;
open(F,"<$rwpath/template/admin.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub restore_message
{
open(F,"$messpath/admin.msg");
@file=<F>;
close(F);
$file=join("",@file);
($header,@body)=split("\n\n",$file);
$body=join("\n\n",@body);
@header=split("\n",$header);
$subject=$header[1];
$subject=~s/^Subject: //;
&maillist;
}
sub sendmail
{
$selected{maillist}="selected";
$data{body}=~s/\r//g;
open(MAIL,">$messpath/admin.msg");
print MAIL "From: $data{sender}\n";
print MAIL "Subject: $data{subject}\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT mail_header,mail_footer FROM rw_settings");
($header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
print MAIL "$header\n";
print MAIL "Its not spam, but $title (RingWorld Home) Newsletter $ltime\n";
print MAIL "From: $data{senname}\n\n";
print MAIL "-" x 75 . "\n\n";
print MAIL "$data{body}\n\n";
print MAIL "$footer\n";
close(MAIL);
srand;
$randnum=rand;
$result=qq~<tr><td align=center><font size=2>Sending newsletter...</font></td></tr>
<script type="text/javascript" language="Javascript">
window.open("$cgi/nph-rwamail.pl?method=maillist&recepient=$data{recepient}&name=$data{name}&password=$data{password}&randnum=$randnum", 'f', 'toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=no,width=113,height=135');
</script>
~;
&closedb;
open(F,"<$rwpath/template/admin.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub downmail
{
if ($data{recepient} eq "all")
{
	$sth=$dbh->query("LOCK TABLES rw_users READ") if ($locktables);
	$sth=$dbh->query("SELECT DISTINCT email,name FROM rw_users ORDER BY name");
	while (($email,$name)=$sth->fetchrow)
	{
		$file.="$email\t$name\n";
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
elsif ($data{recepient} eq "ringleader")
{
	$sth=$dbh->query("LOCK TABLES rw_users READ, rw_rings READ") if ($locktables);
	$sth=$dbh->query("SELECT DISTINCT email,name FROM rw_users,rw_rings WHERE rw_rings.uid=rw_users.uid ORDER BY name");
	while (($email,$name)=$sth->fetchrow)
	{
		$file.="$email\t$name\n";
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
else
{
	$sth=$dbh->query("LOCK TABLES rw_users READ, rw_sites READ") if ($locktables);
	$sth=$dbh->query("SELECT DISTINCT email,name FROM rw_users,rw_sites WHERE (rid=$data{recepient} AND rw_sites.uid=rw_users.uid) ORDER BY name");
	while (($email,$name)=$sth->fetchrow)
	{
		$file.="$email\t$name\n";
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&closedb;
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-disposition: filename=\"ringworld.mls\"; \n";
print "content-type: application/rw_maillist\n\n";
print $file;
exit;
}
sub error
{
@errors=@_;
&closedb;
open(F,"<$rwpath/template/error.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}	
sub logout
{
&closedb;
print "HTTP/1.0 302 Found\n" if ($sysid eq "Windows");
print "Location: $furl\n\n";
}
sub categ
{
$selected{categ}="selected";
$result=qq~
<tr><td width="100%" bgcolor="#CECE00" align=center><font face="Arial" size="2" color="#000000">REMOVE CATEGORY</font></td></tr>
<tr><td><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="remcateg">
<table width="100%">
~;
$sth=$dbh->query("LOCK TABLES rw_categories READ") if ($locktables);
$sth=$dbh->query("SELECT caid,category,subcategory FROM rw_categories ORDER BY category,subcategory");
while (($caid,$category,$subcategory)=$sth->fetchrow)
{
	if ($categ{$category}){$categ{$category}="$categ{$category}##$subcategory";}
	else {$categ{$category}=$subcategory;}
	$tfield="$category-$subcategory";
	$id{$tfield}=$caid;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
foreach $key (sort keys %categ)
{
	$result.="<tr><td colspan=2><font size=2 color=red><b>$key</b></font></td></tr>";
	@temp=split("##",$categ{$key});
	$i=0;
	while($i<scalar(@temp))
	{
		$tfield="$key-$temp[$i]";
		$result.="<tr><td width=\"10%\"><input type=checkbox name=target value=\"$id{$tfield}\"></td><td width=\"40%\"><font size=2>$temp[$i]</font></td>";
		$i++;
		if ($temp[$i] ne "")
		{
		$tfield="$key-$temp[$i]";
		$result.="<td width=\"10%\"><input type=checkbox name=target value=\"$id{$tfield}\"></td><td width=\"40%\"><font size=2>$temp[$i]</font></td></tr>\n";
		}
		else {$result.="<td></td><td></td></tr>\n";}
		$i++;
	}
}
$result.="</table><p align=\"right\"><input type=submit value=Remove></p></form></center></font></td></tr>";
$result.=qq~
<tr><td width="100%" bgcolor="#CECE00" align=center><font face="Arial" size="2" color="#000000">ADD CATEGORY</font></td></tr>
<tr><td><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="addcateg">
<table border="0" width="100%" cellpadding="0">
<tr><td width="40%"><font size=1><b>Category name</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="categ"></font></td></tr>
<tr><td width="40%"><font size=1><b>Subcategory name</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="subcateg"></font></td></tr>
<tr><td colspan=2 align="right"><input type="submit" value="Add category"></td></tr>
</table></form>
</td></tr>
~;
&closedb;
open(F,"<$rwpath/template/admin.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub addcateg
{
if ($data{categ} && $data{subcateg})
{
	$data{categ}=~s/'/\\'/g;
	$data{subcateg}=~s/'/\\'/g;
	$sth=$dbh->query("LOCK TABLES rw_categories WRITE") if ($locktables);
	$sth=$dbh->query("INSERT INTO rw_categories (category,subcategory) VALUES ('$data{categ}','$data{subcateg}')");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&categ;
}
sub remcateg
{
$selected{categ}="selected";
if ($data{target})
{
$result=qq~
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>ARE YOU SURE TO REMOVE CATEGORIES?</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="remcateg_c"><input type="hidden" name="target" value="$data{target}">
<table width="100%">
<tr><td><font size=2><b>All webrings belong to choosen categories should be removed too</b></font></td></tr>
<tr><td align="center"><input type="submit" value="Yes, Im sure"></td></tr>
</table></form></td></tr>
~;
&closedb;
open(F,"<$rwpath/template/admin.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
&categ;
}
sub remcateg_c
{
if ($data{target})
{
	@target=split(",",$data{target});
	$sth=$dbh->query("LOCK TABLES rw_categories WRITE") if ($locktables);
	foreach(@target)
	{
		$sth=$dbh->query("DELETE FROM rw_categories WHERE caid=$_");
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
	foreach(@target)
	{
		$sth=$dbh->query("SELECT rid FROM rw_rings WHERE caid=$_");
		@temp=$sth->fetchcol;
		@rids=(@rids,@temp);
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	if (@rids)
	{
		$sth=$dbh->query("LOCK TABLES rw_rings WRITE, rw_sites WRITE") if ($locktables);
		foreach(@rids)
		{
			$sth=$dbh->query("DELETE FROM rw_rings WHERE rid=$_");
			$sth=$dbh->query("DELETE FROM rw_sites WHERE rid=$_");
		}
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	}
}
&categ;
}
sub systools
{
$selected{systools}="selected";
$status.="Backup system status:<br>";
opendir(Dir,"$backuppath");
@files=readdir(Dir);
closedir(Dir);
shift(@files);
shift(@files);
if (@files)
{
	($atime,$mtime)=(stat("$backuppath/$files[0]"))[8,9];
	($day,$month,$date,$time,$year)=split(" ",scalar localtime($mtime));
	$status.="Database was backed up on $date/$month/$year $time";
}
else
{
	$status.="Database wasnt backed up.";
}
$result=qq~
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>BACKUP DATABASE</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="backup_data">
<table width="100%">
<tr><td colspan=2><font size=2>$status</font></td></tr>
<tr><td width="40%"><font size=2><b>Backup database tables</b></font></td><td width="60%" align="right"><font size=2><input type=submit value="Proceed"></font></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>RESTORE DATABASE</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="install_backup">
<table width="100%">
<tr><td width="40%"><font size=2><b>Restore database tables</b></font></td><td width="60%" align="right"><font size=2><input type=submit value="Proceed"></font></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>DELETE BACKUP</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="delete_backup">
<table width="100%">
<tr><td width="40%"><font size=2><b>Delete backup copy</b></font></td><td width="60%" align="right"><font size=2><input type=submit value="Proceed"></font></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>DOWNLOAD SQL DUMP</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="sql_dump">
<table width="100%">
<tr><td width="40%"><font size=2><b>Download SQL script</b></font></td><td width="60%" align="right"><font size=2><input type=submit value="Proceed"></font></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>RESET DATABASE</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="reset_db">
<table width="100%">
<tr><td width="40%"><font size=2><b>Reset all tables</b></font></td><td width="60%" align="right"><font size=2><input type=submit value="Proceed"></font></td></tr>
</table></form></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>RESET STATS</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="reset_stats">
<table width="100%">
<tr><td width="40%"><font size=2><b>Reset sites stats</b></font></td><td width="60%" align="right"><font size=2><input type=submit value="Proceed"></font></td></tr>
</table></form></td></tr>
~;
&closedb;
open (F,"<$rwpath/template/admin.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub backup_data
{
$sth=$dbh->query("LOCK TABLES rw_users WRITE, rw_rings WRITE, rw_sites WRITE, rw_categories WRITE, mw_settings WRITE") if ($locktables);
$sth=$dbh->query("BACKUP TABLE rw_users,rw_rings,rw_sites,rw_categories,rw_settings TO '$backuppath'");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&systools;
}
sub delete_backup
{
opendir(Dir,"$backuppath");
@files=readdir(Dir);
closedir(Dir);
shift(@files);
shift(@files);
foreach(@files)
{
	unlink("$backuppath/$_");
}
&systools;
}
sub install_backup
{
opendir(Dir,"$backuppath");
@files=readdir(Dir);
closedir(Dir);
shift(@files);
shift(@files);
if(@files)
{
	$sth=$dbh->query("LOCK TABLES rw_users WRITE, rw_rings WRITE, rw_sites WRITE, rw_categories WRITE, mw_settings WRITE") if ($locktables);
	$sth=$dbh->query("DROP TABLE rw_users,rw_rings,rw_sites,rw_categories,rw_settings");
	$sth=$dbh->query("RESTORE TABLE rw_users,rw_rings,rw_sites,rw_categories,rw_settings FROM '$backuppath'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&systools;
}
sub sql_dump
{
$file="CREATE TABLE rw_users (uid MEDIUMINT(6) UNSIGNED NOT NULL auto_increment,email VARCHAR(255) NOT NULL,username VARCHAR(8) NOT NULL,password VARCHAR(8) NOT NULL,name VARCHAR(150) NOT NULL,acctype TINYINT(1) NOT NULL,status TINYINT(1),lastdate DATETIME,lastsip VARCHAR(15),lastuip VARCHAR(15),PRIMARY KEY (uid),INDEX (uid,email,username,acctype,status));\n";
$sth=$dbh->query("LOCK TABLES rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM rw_users");
while (($uid,$email,$username,$password,$name,$acctype,$status,$lastdate,$lastsip,$lastuip)=$sth->fetchrow)
{
	$file.="INSERT INTO rw_users (uid,email,username,password,name,acctype,status,lastdate,lastsip,lastuip) VALUES ($uid,'$email','$username','$password','$name',$acctype,$status,'$lastdate','$lastsip','$lastuip');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$file.="CREATE TABLE rw_rings (rid MEDIUMINT(4) UNSIGNED NOT NULL auto_increment,uid MEDIUMINT(6) UNSIGNED NOT NULL,rname VARCHAR(100) NOT NULL,rurl VARCHAR(255),caid MEDIUMINT(3),stype TINYINT(1) UNSIGNED,rdescr TEXT,hcode TEXT,PRIMARY KEY (rid),INDEX (rid,uid,rname,caid));\n";
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM rw_rings");
while (($rid,$uid,$rname,$rurl,$caid,$stype,$rdescr,$hcode)=$sth->fetchrow)
{
	$file.="INSERT INTO rw_rings (rid,uid,rname,rurl,caid,stype,rdescr,hcode) VALUES ($rid,$uid,'$rname','$rurl',$caid,$stype,'$rdescr','$hcode');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$file.="CREATE TABLE rw_sites (sid MEDIUMINT(8) UNSIGNED NOT NULL auto_increment,rid MEDIUMINT(4) UNSIGNED NOT NULL,uid MEDIUMINT(6) UNSIGNED NOT NULL,sname VARCHAR(100),surl VARCHAR(255),hits MEDIUMINT(8) UNSIGNED,sdescr TEXT,PRIMARY KEY (sid),INDEX (sid,rid,uid,sname));\n";
$sth=$dbh->query("LOCK TABLES rw_sites READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM rw_sites");
while (($sid,$rid,$uid,$sname,$surl,$hits,$sdescr)=$sth->fetchrow)
{
	$file.="INSERT INTO rw_sites (sid,rid,uid,sname,surl,hits,sdescr) VALUES ($sid,$rid,$uid,'$sname','$surl',$hits,'$sdescr');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$file.="CREATE TABLE rw_categories (caid MEDIUMINT(3) UNSIGNED NOT NULL auto_increment,category VARCHAR(50) NOT NULL,subcategory VARCHAR(50) NOT NULL,PRIMARY KEY (caid),INDEX (caid,category,subcategory));\n";
$sth=$dbh->query("LOCK TABLES rw_categories READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM rw_categories");
while (($caid,$category,$subcategory)=$sth->fetchrow)
{
	$file.="INSERT INTO rw_categories (caid,category,subcategory) VALUES ($caid,'$category','$subcategory');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$file.="CREATE TABLE rw_settings (hcode TEXT);\n";
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM rw_settings");
while ($hcode=$sth->fetchrow)
{
	$file.="INSERT INTO rw_settings (hcode) VALUES ('$hcode');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-disposition: filename=\"rw_tables.sql\"; \n";
print "content-type: application/sqldump\n\n";
print $file;
exit;
}
sub reset_db
{
$selected{systools}="selected";
$result=qq~
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>ARE YOU SURE TO RESET DATABASE?</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="reset_db1">
<table width="100%">
<tr><td><font size=2><b>All information in database will be destroyed. All logos and messages will be removed also.</b></font></td></tr>
<tr><td align="center"><input type="submit" value="Yes, Im sure"></td></tr>
</table></form></td></tr>
~;
&closedb;
open (F,"<$rwpath/template/admin.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub reset_db1
{
$sth=$dbh->query("LOCK TABLES rw_users WRITE, rw_rings WRITE, rw_sites WRITE, rw_categories WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM rw_users");
$sth=$dbh->query("DELETE FROM rw_rings");
$sth=$dbh->query("DELETE FROM rw_sites");
$sth=$dbh->query("DELETE FROM rw_categories");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
opendir(Dir,"$messpath");
@files=readdir(Dir);
closedir(Dir);
shift(@files);
shift(@files);
foreach(@files){unlink("$messpath/$_");}
opendir(Dir,"$rwpath/logo");
@files=readdir(Dir);
closedir(Dir);
shift(@files);
shift(@files);
foreach(@files){unlink("$rwpath/logo/$_");}
&systools;
}
sub reset_stats
{
$selected{systools}="selected";
$result=qq~
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>ARE YOU SURE TO RESET STATS?</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwadmin.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="reset_stats1">
<table width="100%">
<tr><td><font size=2><b>All sites hits will be set to 0.</b></font></td></tr>
<tr><td align="center"><input type="submit" value="Yes, Im sure"></td></tr>
</table></form></td></tr>
~;
&closedb;
open (F,"<$rwpath/template/admin.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub reset_stats1
{
$sth=$dbh->query("LOCK TABLES rw_sites WRITE") if ($locktables);
$sth=$dbh->query("UPDATE rw_sites SET hits=0");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&systools;
}
sub closedb
{
$sth="";
$dbh="";
}
